--------------------INFO--------------------
-- Doppelganger/PlayerInfu. Modifed version of CombatInfoFu. Modified on 03-20-07.
-- This addon has been modified by the Doppleganger! (Kayde of Alleria). 
-- Much credit is due to Detritis [CombatInfoFu] for his coding work there. 
-- I took what was missing from that setup and improved upon the layout by mirroring what changes I made in my CritterInFu addon.
-- Colorized text now for all buffed stats.
-- Collapsable sections for things you don't want/need displayed.
-- Code reduction and optimization to streamline the layout for a smaller footprint and overall memory usage.
-- Updated several features that were using outdated coding to get same results (I believe).


--------------------GLOBALS/LOCALS/DEFAULTS--------------------
PlayerInFu = AceLibrary("AceAddon-2.0"):new("FuBarPlugin-2.0", "AceConsole-2.0", "AceDB-2.0", "AceEvent-2.0")

local L			= AceLibrary("AceLocale-2.2"):new("PlayerInFu")
local crayon	= AceLibrary("Crayon-2.0")
local dewdrop	= AceLibrary("Dewdrop-2.0")
local tablet	= AceLibrary("Tablet-2.0")

-- register database stuff
PlayerInFu:RegisterDB("PlayerInFuDB")

PlayerInFu:RegisterDefaults('profile', {
	showPlayerName = true,
	showPlayerLevel = true,
	showPlayerXPN = true,
	showPlayerXPP = true,
	showPlayerXPR = true,
	showExperience = true,
	showAttributes = true,
	showDefense = true,
	showMelee = true,
	showRanged = true,
	showSpell = true,
	showTalents = true,
})
PlayerInFu:RegisterChatCommand(L["CMD_OPTIONS"], options)

-- properties
PlayerInFu.clickableTooltip		= true
PlayerInFu.canHideText			= true
PlayerInFu.defaultPosition		= "CENTER"
PlayerInFu.hasIcon				= true
PlayerInFu.hasNoColor			= false
PlayerInFu.OnMenuRequest 		= optionsTable
PlayerInFu.independentProfile	= true


--------------------INITIALIZE/ENABLE/DISABLE--------------------
function PlayerInFu:OnInitialize()
end

function PlayerInFu:OnEnable()
	self:RegisterEvent("CHAT_MSG_SKILL","Update")
	self:RegisterEvent("PLAYER_ENTERING_WORLD","Update")
	self:RegisterEvent("PLAYER_LEVEL_UP","Update")
	self:RegisterEvent("SPELLS_CHANGED","Update")
	self:RegisterEvent("UNIT_AURA","Update")
	self:RegisterEvent("UNIT_AURASTATE","Update")
	self:RegisterEvent("UNIT_INVENTORY_CHANGED","Update")
end

function PlayerInFu:OnDisable()
	self:UnregisterAllEvents()
end

--------------------EVENTS/FUNCTIONS--------------------
function PlayerInFu:IsHunter()
	local _, englishClass = UnitClass("player")
	return englishClass == "HUNTER"
end
function PlayerInFu:IsWarrior()
	local _, englishClass = UnitClass("player")
	return englishClass == "WARRIOR"
end
function PlayerInFu:IsRogue()
	local _, englishClass = UnitClass("player")
	return englishClass == "ROGUE"
end

--Toggle Action Template
function PlayerInFu:ToggleCategory(id, button) 
	self.db.profile[id] = not self.db.profile[id]
	self:UpdateTooltip()
end

--Header Name
function PlayerInFu:IsShowingHPlayerName()
	return self.db.profile.showPlayerName
end
function PlayerInFu:ToggleIsShowingHPlayerName()
	self.db.profile.showPlayerName = not self.db.profile.showPlayerName
	if not (self.db.profile.showPlayerName or self.db.profile.showPlayerLevel or self.db.profile.showPlayerXPN or self.db.profile.showPlayerXPR or self.db.profile.showPlayerXPP) then self:ShowIcon() end
	self:UpdateText()
	return self.db.profile.showPlayerName
end
--Header Level
function PlayerInFu:IsShowingHPlayerLevel()
	return self.db.profile.showPlayerLevel
end
function PlayerInFu:ToggleIsShowingHPlayerLevel()
	self.db.profile.showPlayerLevel = not self.db.profile.showPlayerLevel
	if not (self.db.profile.showPlayerName or self.db.profile.showPlayerLevel or self.db.profile.showPlayerXPN or self.db.profile.showPlayerXPR or self.db.profile.showPlayerXPP) then self:ShowIcon() end
	self:UpdateText()
	return self.db.profile.showPlayerLevel
end
--Header XP (Numbers)
function PlayerInFu:IsShowingHPlayerXPN()
	return self.db.profile.showPlayerXPN
end
function PlayerInFu:ToggleIsShowingHPlayerXPN()
	self.db.profile.showPlayerXPN = not self.db.profile.showPlayerXPN
	if not (self.db.profile.showPlayerName or self.db.profile.showPlayerLevel or self.db.profile.showPlayerXPN or self.db.profile.showPlayerXPR or self.db.profile.showPlayerXPP) then self:ShowIcon() end
	self:UpdateText()
	return self.db.profile.showPlayerXPN
end
--Header XP (Percentage)
function PlayerInFu:IsShowingHPlayerXPP()
	return self.db.profile.showPlayerXPP
end
function PlayerInFu:ToggleIsShowingHPlayerXPP()
	self.db.profile.showPlayerXPP = not self.db.profile.showPlayerXPP
	if not (self.db.profile.showPlayerName or self.db.profile.showPlayerLevel or self.db.profile.showPlayerXPN or self.db.profile.showPlayerXPR or self.db.profile.showPlayerXPP) then self:ShowIcon() end
	self:UpdateText()
	return self.db.profile.showPlayerXPP
end
--Header XP (Rested)
function PlayerInFu:IsShowingHPlayerXPR()
	return self.db.profile.showPlayerXPR
end
function PlayerInFu:ToggleIsShowingHPlayerXPR()
	self.db.profile.showPlayerXPR = not self.db.profile.showPlayerXPR
	if not (self.db.profile.showPlayerName or self.db.profile.showPlayerLevel or self.db.profile.showPlayerXPN or self.db.profile.showPlayerXPR or self.db.profile.showPlayerXPP) then self:ShowIcon() end
	self:UpdateText()
	return self.db.profile.showPlayerXPR
end


--Tooltip XP
function PlayerInFu:IsShowingExperience()
	return self.db.profile.showExperience
end
function PlayerInFu:ToggleIsShowingExperience()
	self.db.profile.showExperience = not self.db.profile.showExperience
	self:UpdateTooltip()
	return self.db.profile.showExperience
end
--Tooltip Attributes
function PlayerInFu:IsShowingAttributes()
	return self.db.profile.showAttributes
end
function PlayerInFu:ToggleIsShowingAttributes()
	self.db.profile.showAttributes = not self.db.profile.showAttributes
	self:UpdateTooltip()
	return self.db.profile.showAttributes
end
--Tooltip Defense
function PlayerInFu:IsShowingDefense()
	return self.db.profile.showDefense
end
function PlayerInFu:ToggleIsShowingDefense()
	self.db.profile.showDefense = not self.db.profile.showDefense
	self:UpdateTooltip()
	return self.db.profile.showDefense
end
--Tooltip Melee
function PlayerInFu:IsShowingMelee()
	return self.db.profile.showMelee
end
function PlayerInFu:ToggleIsShowingMelee()
	self.db.profile.showMelee = not self.db.profile.showMelee
	self:UpdateTooltip()
	return self.db.profile.showMelee
end
--Tooltip Ranged
function PlayerInFu:IsShowingRanged()
	return self.db.profile.showRanged
end
function PlayerInFu:ToggleIsShowingRanged()
	self.db.profile.showRanged = not self.db.profile.showRanged
	self:UpdateTooltip()
	return self.db.profile.showRanged
end
--Tooltip Spells
function PlayerInFu:IsShowingSpell()
	return self.db.profile.showSpell
end
function PlayerInFu:ToggleIsShowingSpell()
	self.db.profile.showSpell = not self.db.profile.showSpell
	self:UpdateTooltip()
	return self.db.profile.showSpell
end
--Tooltip Talents
function PlayerInFu:IsShowingTalents()
	return self.db.profile.showTalents
end
function PlayerInFu:ToggleIsShowingTalents()
	self.db.profile.showTalents = not self.db.profile.showTalents
	self:UpdateTooltip()
	return self.db.profile.showTalents
end

--Spell Crit Percentage from all schools
function PlayerInFu:GetRealSpellCrit()
	local holySchool = 2
	local minCrit = GetSpellCritChance(holySchool)
	local spellCrit
	this.spellCrit = {}
	this.spellCrit[holySchool] = minCrit
	for i=(holySchool+1), 7 do
		spellCrit = GetSpellCritChance(i)
		minCrit = min(minCrit, spellCrit)
		this.spellCrit[i] = spellCrit
	end
	minCrit = format("%.2f%%", minCrit)
	return minCrit
end


--------------------DROP DOWN MENU OPTIONS--------------------	
function PlayerInFu:OnMenuRequest(level, value)
	if level == 1 then
		-- Header Bar Options
		dewdrop:AddLine(
			'text', L["HEAD_OPTIONS"],
			'arg1', self,
			'hasArrow', true,
			'value', "H_OPTIONS"
		)
		-- Tooltip Options
		dewdrop:AddLine(
			'text', L["TOOL_OPTIONS"],
			'arg1', self,
			'hasArrow', true,
			'value', "T_OPTIONS"
		)
		dewdrop:AddLine()
	end
	if level == 2 then
		-- Header Bar/Tooltip Option Submenu
		if value == "H_OPTIONS" then
			-- Display Name
			dewdrop:AddLine(
				'text', L["H_NAME"],
				'tooltipTitle', L["H_NAME"],
				'tooltipText', L["H_NAME_TEXT"],
				'func', 'ToggleIsShowingHPlayerName',
				'arg1', self,
				'closeWhenClicked', false,				 
				'checked', self:IsShowingHPlayerName()
			)
			-- Display Level
			dewdrop:AddLine(
				'text', L["H_LVL"],
				'tooltipTitle', L["H_LVL"],
				'tooltipText', L["H_LVL_TEXT"],
				'func', 'ToggleIsShowingHPlayerLevel',
				'arg1', self,
				'closeWhenClicked', false, 
				'checked', self:IsShowingHPlayerLevel()
			)
			-- Header Bar XP Options
			dewdrop:AddLine(
				'text', L["HEAD_XP_OPTIONS"],
				'arg1', self,
				'hasArrow', true,
				'value', "H_XP_OPTIONS"
			)
		end
		-- Toggle Option Submenu
		if value == "T_OPTIONS" then
			-- Toggle Experience
			dewdrop:AddLine(
				'text', L["TT_EXP"],
				'tooltipTitle', L["TT_EXP"],
				'tooltipText', L["TT_EXP_TEXT"],
				'func', 'ToggleIsShowingExperience',
				'arg1', self,
				'closeWhenClicked', false, 
				'checked', self:IsShowingExperience()
			)
			-- Toggle Attributes
			dewdrop:AddLine(
				'text', L["TT_ATT"],
				'tooltipTitle', L["TT_ATT"],
				'tooltipText', L["TT_ATT_TEXT"],
				'func', 'ToggleIsShowingAttributes',
				'arg1', self,
				'closeWhenClicked', false, 
				'checked', self:IsShowingAttributes()
			)
			-- Toggle Defensive Skills
			dewdrop:AddLine(
				'text', L["TT_DEFENSE"],
				'tooltipTitle', L["TT_DEFENSE"],
				'tooltipText', L["TT_DEFENSE_TEXT"],
				'func', 'ToggleIsShowingDefense',
				'arg1', self,
				'closeWhenClicked', false, 
				'checked', self:IsShowingDefense()
			)
			-- Toggle Melee Skills
			dewdrop:AddLine(
				'text', L["TT_MELEE"],
				'tooltipTitle', L["TT_MELEE"],
				'tooltipText', L["TT_MELEE_TEXT"],
				'func', 'ToggleIsShowingMelee',
				'arg1', self,
				'closeWhenClicked', false, 
				'checked', self:IsShowingMelee()
			)
			-- Toggle Ranged Skills
			if self:IsHunter() or self:IsWarrior() or self:IsRogue() then
				dewdrop:AddLine(
					'text', L["TT_RANGED"],
					'tooltipTitle', L["TT_RANGED"],
					'tooltipText', L["TT_RANGED_TEXT"],
					'func', 'ToggleIsShowingRanged',
					'arg1', self,
					'closeWhenClicked', false, 
					'checked', self:IsShowingRanged()
				)
			end
			-- Toggle Spell Skills
			if not (self:IsHunter() or self:IsWarrior() or self:IsRogue()) then
				dewdrop:AddLine(
					'text', L["TT_SPELL"],
					'tooltipTitle', L["TT_SPELL"],
					'tooltipText', L["TT_SPELL_TEXT"],
					'func', 'ToggleIsShowingSpell',
					'arg1', self,
					'closeWhenClicked', false, 
					'checked', self:IsShowingSpell()
				)
			end
			-- Toggle Talents
			dewdrop:AddLine(
				'text', L["TT_TALENTS"],
				'tooltipTitle', L["TT_TALENTS"],
				'tooltipText', L["TT_TALENTS_TEXT"],
				'func', 'ToggleIsShowingTalents',
				'arg1', self,
				'closeWhenClicked', false, 
				'checked', self:IsShowingTalents()
			)
		end
	end
	if level == 3 then
		-- Header Bar/Tooltip XP Option Submenu
		if value == "H_XP_OPTIONS" then
			-- Display XP Name
			dewdrop:AddLine(
				'text', L["H_XPN"],
				'tooltipTitle', L["H_XPN"],
				'tooltipText', L["H_XPN_TEXT"],
				'func', 'ToggleIsShowingHPlayerXPN',
				'arg1', self,
				'closeWhenClicked', false, 
				'checked', self:IsShowingHPlayerXPN()
			)
			-- Display XP Percentage
			dewdrop:AddLine(
				'text', L["H_XPP"],
				'tooltipTitle', L["H_XPP"],
				'tooltipText', L["H_XPP_TEXT"],
				'func', 'ToggleIsShowingHPlayerXPP',
				'arg1', self,
				'closeWhenClicked', false, 
				'checked', self:IsShowingHPlayerXPP()
			)
			-- Display XP Rested
			dewdrop:AddLine(
				'text', L["H_XPR"],
				'tooltipTitle', L["H_XPR"],
				'tooltipText', L["H_XPR_TEXT"],
				'func', 'ToggleIsShowingHPlayerXPR',
				'arg1', self,
				'closeWhenClicked', false, 
				'checked', self:IsShowingHPlayerXPR()
			)
		end
	end
end



--------------------TOOLTIP UPDATE--------------------	
function PlayerInFu:OnTooltipUpdate()
	--TOOLTIP SETUP
	local toolTip = tablet:AddCategory(
		'columns', 2,
		'child_textR', 1,
		'child_textG', 0.8,
		'child_textB', 0
	)
	local C1 = "|cffffffff"
	local C2 = "|cffa6a6ff"
	local C3 = "|cff20ff20"
	local pLVL = UnitLevel("player")
	
	--SPACER
	toolTip:AddLine()
	
	--PLAYER INFO (NAME, LEVEL, CLASS)
	toolTip:AddLine(
		'text', "    "..UnitName("player"),
		'text2', L["PLEVEL"]..pLVL.." "..UnitClass("player").." "
	)
	--TT_EXP
	if self.db.profile.showExperience then  
		local tooltipLine = tablet:AddCategory('id', L["TT_EXP"], 'columns', 2,
												'text', L["TT_EXP"],
												'func', 'ToggleCategory', 'arg1', self, 'arg2', L["TT_EXP"],
												'child_textR', 1, 'child_textG', 0.8, 'child_textB', 0,
												'showWithoutChildren', true,
												'checked', true, 'hasCheck', true, 'checkIcon',
												self.db.profile[L["TT_EXP"]] and 
												'Interface\\Buttons\\UI-PlusButton-Up' or 'Interface\\Buttons\\UI-MinusButton-Up'
		)
		if not self.db.profile[L["TT_EXP"]] then
			local cXP = UnitXP("player")
			local nXP = UnitXPMax("player")
			local currentXP = C1..cXP.." / "..nXP..C2..format(" (%.1f%%)", (cXP / nXP * 100))
			--Current/Needed XP
			tooltipLine:AddLine(
				'text', "    "..L["CURR_XP"], 
				'text2', currentXP.." "
			)
			if pLVL ~= 70 then
				local neededXP = C1..(nXP - cXP)..C2..format(" (%.1f%%)", (100 - cXP / nXP * 100))
				local rXP = GetXPExhaustion()
				--XP to Go
				tooltipLine:AddLine(
					'text', "    "..L["NEED_XP"], 
					'text2', neededXP.." "
				)
				--Rested XP
				if(rXP ~= nil) then
					local restedXP = C3..rXP..C2..format(" (%.1f %%)", ((rXP / nXP) * 100))
					tooltipLine:AddLine(
						'text', "    "..L["REST_XP"], 
						'text2', restedXP.." "
					)
				end
			end
		end
	end
	--TT_ATT
	if self.db.profile.showAttributes then  
		local tooltipLine = tablet:AddCategory('id', L["TT_ATT"], 'columns', 2,
												'text', L["TT_ATT"],
												'func', 'ToggleCategory', 'arg1', self, 'arg2', L["TT_ATT"],
												'child_textR', 1, 'child_textG', 0.8, 'child_textB', 0,
												'showWithoutChildren', true,
												'checked', true, 'hasCheck', true, 'checkIcon',
												self.db.profile[L["TT_ATT"]] and 
												'Interface\\Buttons\\UI-PlusButton-Up' or 'Interface\\Buttons\\UI-MinusButton-Up'
		)
		if not self.db.profile[L["TT_ATT"]] then
			--STR, AGI, STA, INT, SPI
			local bStr, tStr, pStr, nStr = UnitStat("player",1)
			local bAgi, tAgi, pAgi, nAgi = UnitStat("player",2)
			local bSta, tSta, pSta, nSta = UnitStat("player",3)
			local bInt, tInt, pInt, nInt = UnitStat("player",4)
			local bSpi, tSpi, pSpi, nSpi = UnitStat("player",5)
			if pStr == 0 and nStr == 0 then bStr = tStr
			  elseif nStr < 0 then bStr = crayon:Red(tStr)
			  else bStr = crayon:Green(tStr)
			end
			if pAgi == 0 and nAgi == 0 then bAgi = tAgi
			  elseif nAgi < 0 then bAgi = crayon:Red(tAgi)
			  else bAgi = crayon:Green(tAgi)
			end
			if pSta == 0 and nSta == 0 then bSta = tSta
			  elseif nSta < 0 then bSta = crayon:Red(tSta)
			  else bSta = crayon:Green(tSta)
			end
			if pInt == 0 and nInt == 0 then bInt = tInt
			  elseif nInt < 0 then bInt = crayon:Red(tInt)
			  else bInt = crayon:Green(tInt)
			end
			if pSpi == 0 and nSpi == 0 then bSpi = tSpi
			  elseif nSpi < 0 then bSpi = crayon:Red(tSpi)
			  else bSpi = crayon:Green(tSpi)
			end
			--ARCANE, FIRE, NATURE, FROST, SHADOW
			local bArc, tArc, pArc, nArc = UnitResistance("player", 6)
			local bFir, tFir, pFir, nFir = UnitResistance("player", 2)
			local bNat, tNat, pNat, nNat = UnitResistance("player", 3)
			local bFst, tFst, pFst, nFst = UnitResistance("player", 4)
			local bShw, tShw, pShw, nShw = UnitResistance("player", 5)
			if pArc == 0 and nArc == 0 then bArc = tArc
			  elseif nArc < 0 then bArc = crayon:Red(tArc)
			  else bArc = crayon:Green(tArc)
			end
			if pFir == 0 and nFir == 0 then bFir = tFir
			  elseif nFir < 0 then bFir = crayon:Red(tFir)
			  else bFir = crayon:Green(tFir)
			end
			if pNat == 0 and nNat == 0 then bNat = tNat
			  elseif nNat < 0 then bNat = crayon:Red(tNat)
			  else bNat = crayon:Green(tNat)
			end
			if pFst == 0 and nFst == 0 then bFst = tFst
			  elseif nFst < 0 then bFst = crayon:Red(tFst)
			  else bFst = crayon:Green(tFst)
			end
			if pShw == 0 and nShw == 0 then bShw = tShw
			  elseif nShw < 0 then bShw = crayon:Red(tShw)
			  else bShw = crayon:Green(tShw)
			end
			tooltipLine:AddLine(
				'text', "    "..L["STR"]..C1..bStr,
				'text2', L["ARCANE"]..C1..bArc.." ",
				'text2R', 1, 'text2G', 0.8, 'text2B', 0
			)
			tooltipLine:AddLine(
				'text', "    "..L["AGI"]..C1..bAgi,
				'text2', L["FIRE"]..C1..bFir.." ",
				'text2R', 1, 'text2G', 0.8, 'text2B', 0
			)
			tooltipLine:AddLine(
				'text', "    "..L["STA"]..C1..bSta,
				'text2', L["NATURE"]..C1..bNat.." ",
				'text2R', 1, 'text2G', 0.8, 'text2B', 0
			)
			tooltipLine:AddLine(
				'text', "    "..L["INT"]..C1..bInt,
				'text2', L["FROST"]..C1..bFst.." ",
				'text2R', 1, 'text2G', 0.8, 'text2B', 0
			)
			tooltipLine:AddLine(
				'text', "    "..L["SPI"]..C1..bSpi,
				'text2', L["SHADOW"]..C1..bShw.." ",
				'text2R', 1, 'text2G', 0.8, 'text2B', 0
			)
		end
	end
	--TT_DEFENSE
	if self.db.profile.showDefense then  
		local tooltipLine = tablet:AddCategory('id', L["TT_DEFENSE"], 'columns', 2,
												'text', L["TT_DEFENSE"],
												'func', 'ToggleCategory', 'arg1', self, 'arg2', L["TT_DEFENSE"],
												'child_textR', 1, 'child_textG', 0.8, 'child_textB', 0,
												'showWithoutChildren', true,
												'checked', true, 'hasCheck', true, 'checkIcon',
												self.db.profile[L["TT_DEFENSE"]] and 
												'Interface\\Buttons\\UI-PlusButton-Up' or 'Interface\\Buttons\\UI-MinusButton-Up'
		)
		if not self.db.profile[L["TT_DEFENSE"]] then
			--Health 
			local pTotHealth = UnitHealthMax("player")
			--Armor
			local bArmor, eArmor, tArmor, pArmorBuff, nArmorBuff = UnitArmor("player")
			if pArmorBuff - nArmorBuff < 0 then
				eArmor = crayon:Red(format(eArmor))
			  elseif bArmor < eArmor then 
				eArmor = crayon:Green(format(eArmor))
			end
			--Defense
			local bDefense, pBuffDefense = UnitDefense("player")
			local defRate = GetCombatRating(2)	
			local tDefense = bDefense + pBuffDefense
			if defRate > 0 then tDefense = crayon:Green(format(tDefense)) end
			--Armor Damage Reduction
			local aDmgRed = (tArmor / (tArmor + 10557.5)) * 100
			if pLVL < 70 then
				if pLVL < 60 then
					aDmgRed = (tArmor / (tArmor + ((85 * pLVL) + 400))) * 100
				else
					aDmgRed = (tArmor / (tArmor - 22167.5 + 467.5 * pLVL)) * 100
				end
			end
			if aDmgRed > 75 then aDmgRed = "75.00%" end
			--Defense Hit Reduction
			local dHitRed = math.floor(defRate / (1.5 * 82 / (262 - (3 * pLVL)))) * 0.04
			if pLVL < 61 then
				if pLVL < 10 then
					dHitRed = math.floor(defRate / ((1.5 * 2) / 52)) * 0.04
				else 
					dHitRed = math.floor(defRate / ((1.5 * (pLVL - 8)) / 52)) * 0.04
				end
			end
			--Dodge
			local dodgePer = format("%.2f%%",GetDodgeChance())
			local dComRate = GetCombatRating(3)
			if dComRate > 0 then dodgePer = crayon:Green(dodgePer) end
			--Parry
			local parryPer = format("%.2f%%",GetParryChance())
			local pComRate = GetCombatRating(4)
			if pComRate > 0 then parryPer = crayon:Green(parryPer) end
			--Block
			local blockPer = format("%.2f%%",GetBlockChance())
			local bComRate = GetCombatRating(5)
			if bComRate > 0 then blockPer = crayon:Green(blockPer) end
			--Resilience Crit/Dmg Reduction
			local resMelee = GetCombatRatingBonus(15)
			local resRanged = GetCombatRatingBonus(16)
			local resSpell = GetCombatRatingBonus(17)
			local minRes = min(resMelee, resRanged, resSpell)
			local lowBonus = resMelee
			if resMelee == minRes then
				lowBonus = resMelee
			elseif resRanged == minRes then
				lowBonus = resRanged
			else
				lowBonus = resSpell
			end
			local resChanceRed = lowBonus
			local resDmgRed = lowBonus*2
			
			--Health #, Dodge %
			tooltipLine:AddLine(
				'text', "    "..L["HEALTH"]..C1..pTotHealth,
				'text2', L["DODGE"]..C1..dodgePer.." ",
				'text2R', 1, 'text2G', 0.8, 'text2B', 0
			)
			--Armor #, Parry %
			tooltipLine:AddLine(
				'text', "    "..L["ARMOR"]..C1..eArmor, 
				'text2', L["PARRY"]..C1..parryPer.." ",
				'text2R', 1, 'text2G', 0.8, 'text2B', 0
			)
			--Defense #, Block %
			tooltipLine:AddLine(
				'text', "    "..L["DEFENSE"]..C1..tDefense,
				'text2', L["BLOCK"]..C1..blockPer.." ",
				'text2R', 1, 'text2G', 0.8, 'text2B', 0
			)
			--Armor Dmg Reduct %, ResilienceCrit -%
			tooltipLine:AddLine(
				'text', "    "..L["ADAMRED"]..C1..format("%.2f%%", aDmgRed), 
				'text2', L["RCHANCE"]..C1..format("%.2f%%",resChanceRed).." ",
				'text2R', 1, 'text2G', 0.8, 'text2B', 0
			)
			--Defense Hit Reduct %, ResilienceDmg -%
			tooltipLine:AddLine(
				'text', "    "..L["DHITRED"]..C1..format("%.2f%%", dHitRed), 
				'text2', L["RDMG"]..C1..format("%.2f%%",resDmgRed).." ",
				'text2R', 1, 'text2G', 0.8, 'text2B', 0
			)
		end
	end
	--TT_MELEE
	if self.db.profile.showMelee then  
		local tooltipLine = tablet:AddCategory('id', L["TT_MELEE"], 'columns', 2,
												'text', L["TT_MELEE"]..L["MELEE_TITLE"],
												'func', 'ToggleCategory', 'arg1', self, 'arg2', L["TT_MELEE"],
												'child_textR', 1, 'child_textG', 0.8, 'child_textB', 0,
												'showWithoutChildren', true,
												'checked', true, 'hasCheck', true, 'checkIcon',
												self.db.profile[L["TT_MELEE"]] and 
												'Interface\\Buttons\\UI-PlusButton-Up' or 'Interface\\Buttons\\UI-MinusButton-Up'
		)
		if not self.db.profile[L["TT_MELEE"]] then
			--Main/Off Hand Skill Level
			local bMainSkill, eMainSkill, bOffSkill, eOffSkill = UnitAttackBothHands("player")
			local tMainSkill = bMainSkill + eMainSkill
			local zWeapSkill = format("%.f", tMainSkill)
			if OffhandHasWeapon() then
				local tOffSkill = bOffSkill + eOffSkill
				zWeapSkill = format("%.f | %.f", tMainSkill, tOffSkill)
			end
			--Main/Off Hand Weapon Speed
			local MainSpeed, OffSpeed = UnitAttackSpeed("player")
			local zWeapSpeed = format("%.2f", MainSpeed)
			if OffhandHasWeapon() then
				zWeapSpeed = format("%.2f | %.2f", MainSpeed,OffSpeed)
			end
			--Main/Off Hand Damage Range
			local mLowDmg, mHiDmg, oLowDmg, oHiDmg, pDmgBuff, nDmgBuff, percentMod = UnitDamage("player")
			local tmLowDmg = floor(mLowDmg)
			local tmHiDmg = ceil(mHiDmg)
			local zDmgRng = format("%.f-%.f", tmLowDmg, tmHiDmg)
			if pDmgBuff - nDmgBuff < 0 then
				zDmgRng = crayon:Red(format("%.f-%.f", (tmLowDmg + pDmgBuff + nDmgBuff), (tmHiDmg + pDmgBuff + nDmgBuff)))
			elseif pDmgBuff - nDmgBuff > 0 then
				zDmgRng = crayon:Green(format("%.f-%.f", (tmLowDmg + pDmgBuff + nDmgBuff), (tmHiDmg + pDmgBuff + nDmgBuff)))
			end
			if OffhandHasWeapon() then
				local toLowDmg = floor(oLowDmg)
				local toHiDmg = ceil(oHiDmg)
				if pDmgBuff - nDmgBuff < 0 then
					zDmgRng = crayon:Red(format("%.f-%.f | %.f-%.f", (tmLowDmg + pDmgBuff + nDmgBuff), (tmHiDmg + pDmgBuff + nDmgBuff), (toLowDmg + pDmgBuff + nDmgBuff), (toHiDmg + pDmgBuff + nDmgBuff)))
				elseif pDmgBuff - nDmgBuff > 0 then
					zDmgRng = crayon:Green(format("%.f-%.f | %.f-%.f", (tmLowDmg + pDmgBuff + nDmgBuff), (tmHiDmg + pDmgBuff + nDmgBuff), (toLowDmg + pDmgBuff + nDmgBuff), (toHiDmg + pDmgBuff + nDmgBuff)))
				else
					zDmgRng = format("%.f-%.f | %.f-%.f", tmLowDmg, tmHiDmg, toLowDmg, toHiDmg)
				end
			end
			--Main/Off Hand Damage Per Second
			local mDPS = ((tmLowDmg + tmHiDmg) / 2) / MainSpeed
			local zDPS = format("%.1f", mDPS)
			if OffhandHasWeapon() then
				local toLowDmg = floor(oLowDmg)
				local toHiDmg = ceil(oHiDmg)
				local oDPS = ((toLowDmg + toHiDmg) / 2) / OffSpeed
				zDPS = format("%.1f | %.1f", mDPS, oDPS)
			end
			--Melee Crit Chance Percentage
			local zCrit = format("%.2f%%",GetCritChance())
			--Melee Hit Percent Chance versus Same Level NPC/PC
			local zHitRate = format("%.2f%%", GetCombatRatingBonus(6))
			--Melee Attack Power
			local bAPwr, pAPBuff, nAPBuff = UnitAttackPower("player")
			local zAPwr = format("%.f", (bAPwr + pAPBuff + nAPBuff))
			if pAPBuff - nAPBuff < 0 then
				zAPwr = crayon:Red(format("%.f", (bAPwr + pAPBuff + nAPBuff)))
			elseif pAPBuff - nAPBuff > 0 then
				zAPwr = crayon:Green(format("%.f", (bAPwr + pAPBuff + nAPBuff)))
			end
			--Melee Attack Power Bonus
			local zAPB = "+"..format("%.1f", ((bAPwr + pAPBuff + nAPBuff) / 14))
			
			--Weapon Skill MH/OH, Crit Rating
			tooltipLine:AddLine(
				'text', "    "..L["SKILL"]..C1..zWeapSkill, 
				'text2', L["CRATE"]..C1..zCrit.." ",
				'text2R', 1, 'text2G', 0.8, 'text2B', 0
			)
			--Weapon Speed MH/OH, Hit % vs Lvl x
			tooltipLine:AddLine(
				'text', "    "..L["SPEED"]..C1..zWeapSpeed, 
				'text2', L["HRATE"]..C1..zHitRate.." ",
				'text2R', 1, 'text2G', 0.8, 'text2B', 0
			)
			--Damage Range MH/OH, Attack Power
			tooltipLine:AddLine(
				'text', "    "..L["DMGRNG"]..C1..zDmgRng, 
				'text2', L["ATKPWR"]..C1.."  "..zAPwr.." ",
				'text2R', 1, 'text2G', 0.8, 'text2B', 0
			)
			--Damage Per Second MH/OH, Attack Power Bonus
			tooltipLine:AddLine(
				'text', "    "..L["DPS"]..C1..zDPS, 
				'text2', L["APBONUS"]..C1.." "..zAPB.." ",
				'text2R', 1, 'text2G', 0.8, 'text2B', 0
			)
		end
	end
	--TT_RANGED
	if self.db.profile.showRanged then  
		local tooltipLine = tablet:AddCategory('id', L["TT_RANGED"], 'columns', 2,
												'text', L["TT_RANGED"],
												'func', 'ToggleCategory', 'arg1', self, 'arg2', L["TT_RANGED"],
												'child_textR', 1, 'child_textG', 0.8, 'child_textB', 0,
												'showWithoutChildren', true,
												'checked', true, 'hasCheck', true, 'checkIcon',
												self.db.profile[L["TT_RANGED"]] and 
												'Interface\\Buttons\\UI-PlusButton-Up' or 'Interface\\Buttons\\UI-MinusButton-Up'
		)
		if not self.db.profile[L["TT_RANGED"]] then
			--Ranged Skill Level
			local bRangeSkill, eRangeSkill = UnitRangedAttack("player")
			local tRangeSkill = bRangeSkill + eRangeSkill
			local zrSkill = format("%.f", tRangeSkill)
			--Ranged Weapon Speed
			local rSpd, rLowDmg, rHiDmg, pDmgBuff, nDmgBuff, percentMod  = UnitRangedDamage("player")
			local zrSpd = format("%.2f", rSpd)
			--Ranged Damage Range
			local trLowDmg = floor(rLowDmg)
			local trHiDmg = ceil(rHiDmg)
			local zrDmgRng = format("%.f-%.f", trLowDmg, trHiDmg)
			if pDmgBuff - nDmgBuff < 0 then
				zrDmgRng = crayon:Red(format("%.f-%.f", (trLowDmg + pDmgBuff + nDmgBuff), (trHiDmg + pDmgBuff + nDmgBuff)))
			elseif pDmgBuff - nDmgBuff > 0 then
				zrDmgRng = crayon:Green(format("%.f-%.f", (trLowDmg + pDmgBuff + nDmgBuff), (trHiDmg + pDmgBuff + nDmgBuff)))
			end
			--Ranged Damage Per Second
			local zrDPS = format("%.1f", (((trLowDmg + trHiDmg) / 2) / rSpd))
			--Ranged Crit Chance Percentage
			local zrCrit = format("%.2f%%", GetRangedCritChance())
			--Ranged Hit Percent Chance versus Same Level NPC/PC
			local zrHitRate = format("%.2f%%", GetCombatRatingBonus(6))
			--Ranged Attack Power
			local bRngAPwr, pRngBuff, nRngBuff = UnitRangedAttackPower("player")
			local zRngAPwr = format("%.f", (bRngAPwr + pRngBuff + nRngBuff))
			if pRngBuff - nRngBuff < 0 then
				zRngAPwr = crayon:Red(format("%.f", (bRngAPwr + pRngBuff + nRngBuff)))
			elseif pRngBuff - nRngBuff > 0 then
				zRngAPwr = crayon:Green(format("%.f", (bRngAPwr + pRngBuff + nRngBuff)))
			end
			--Ranged Attack Power Bonus
			local zrAPB = "+"..format("%.1f", ((bRngAPwr + pRngBuff + nRngBuff) / 14))

			--Ranged Skill, Crit Rating
			tooltipLine:AddLine(
				'text', "    "..L["SKILL"]..C1..zrSkill, 
				'text2', L["CRATE"]..C1..zrCrit.." ",
				'text2R', 1, 'text2G', 0.8, 'text2B', 0
			)
			--Ranged Speed, Hit % vs Lvl x
			tooltipLine:AddLine(
				'text', "    "..L["SPEED"]..C1..zrSpd, 
				'text2', L["HRATE"]..C1..zrHitRate.." ",
				'text2R', 1, 'text2G', 0.8, 'text2B', 0
			)
			--Damage Range, Attack Power
			tooltipLine:AddLine(
				'text', "    "..L["DMGRNG"]..C1..zrDmgRng, 
				'text2', L["ATKPWR"]..C1.."  "..zRngAPwr.." ",
				'text2R', 1, 'text2G', 0.8, 'text2B', 0
			)
			--Damage Per Second, Attack Power Bonus
			tooltipLine:AddLine(
				'text', "    "..L["DPS"]..C1..zrDPS, 
				'text2', L["APBONUS"]..C1.." "..zrAPB.." ",
				'text2R', 1, 'text2G', 0.8, 'text2B', 0
			)
		end
	end
	--TT_SPELL
	if self.db.profile.showSpell then
		local tooltipLine = tablet:AddCategory('id', L["TT_SPELL"], 'columns', 2,
												'text', L["TT_SPELL"],
												'func', 'ToggleCategory', 'arg1', self, 'arg2', L["TT_SPELL"],
												'child_textR', 1, 'child_textG', 0.8, 'child_textB', 0,
												'showWithoutChildren', true,
												'checked', true, 'hasCheck', true, 'checkIcon',
												self.db.profile[L["TT_SPELL"]] and 
												'Interface\\Buttons\\UI-PlusButton-Up' or 'Interface\\Buttons\\UI-MinusButton-Up'
		)
		if not self.db.profile[L["TT_SPELL"]] then
			--Bonus Damage
			local zBDmg = GetSpellBonusDamage(2)
			--Bonus Healing
			local zBHeal = GetSpellBonusHealing()
			--Mana Regeneration
			local baseMR, castingMR = GetManaRegen()
			local zMRegen = format("%.f / %.f", floor(baseMR * 5), floor(castingMR * 5))
			--Spell Crit Rate Percentage
			local zsCrit = self:GetRealSpellCrit()
			--Spell Hit Percent Chance versus Same Level NPC/PC
			local zsHitRate = format("%.2f%%", GetCombatRatingBonus(7))
			--Spell Penetration
			local zsPen = GetSpellPenetration()
			
			tooltipLine:AddLine(
				'text', "    "..L["BDMG"]..C1.."+"..zBDmg,
				'text2', L["CRATE"]..C1..zsCrit.." ",
				'text2R', 1, 'text2G', 0.8, 'text2B', 0
			)
			tooltipLine:AddLine(
				'text', "    "..L["BHEAL"]..C1.."+"..zBHeal,  
				'text2', L["HRATE"]..C1..zsHitRate.." ",
				'text2R', 1, 'text2G', 0.8, 'text2B', 0
			)
			tooltipLine:AddLine(
				'text', "    "..L["MANAR"]..C1..zMRegen,
				'text2', L["PEN"]..C1..zsPen.." ",
				'text2R', 1, 'text2G', 0.8, 'text2B', 0
			)
			tooltipLine:AddLine() tooltipLine:AddLine()
		end
	end
	--TT_TALENTS
	if self.db.profile.showTalents then  
		local tooltipLine = tablet:AddCategory('id', L["TT_TALENTS"], 'columns', 2,
												'text', L["TT_TALENTS"],
												'func', 'ToggleCategory', 'arg1', self, 'arg2', L["TT_TALENTS"],
												'child_textR', 1, 'child_textG', 0.8, 'child_textB', 0,
												'showWithoutChildren', true,
												'checked', true, 'hasCheck', true, 'checkIcon',
												self.db.profile[L["TT_TALENTS"]] and 
												'Interface\\Buttons\\UI-PlusButton-Up' or 'Interface\\Buttons\\UI-MinusButton-Up'
		)
		if not self.db.profile[L["TT_TALENTS"]] then
			if pLVL > 9 then
				local n1N, _, n1Tal, _ = GetTalentTabInfo(1)
				local n2N, _, n2Tal, _ = GetTalentTabInfo(2)
				local n3N, _, n3Tal, _ = GetTalentTabInfo(3)
				tooltipLine:AddLine(
					'text', "    "..L["TALPTS"], 
					'text2', C1..UnitCharacterPoints("player").." "
				)
				tooltipLine:AddLine() tooltipLine:AddLine()
				tooltipLine:AddLine(
					'text', "    "..n1N, 
					'text2', C1..n1Tal.." "
				)
				tooltipLine:AddLine(
					'text', "    "..n2N, 
					'text2', C1..n2Tal.." "
				)
				tooltipLine:AddLine(
					'text', "    "..n3N, 
					'text2', C1..n3Tal.." "
				)
			else
				tooltipLine:AddLine(
					'text', "    "..L["NOT10"]
				)
			end
		end
	end
end



--------------------HEADER UPDATE--------------------	
function PlayerInFu:UpdateText()
	if self:IsTextShown() then
		if self.db.profile.showPlayerName or self.db.profile.showPlayerLevel or self.db.profile.showPlayerXPN or self.db.profile.showPlayerXPP or self.db.profile.showPlayerXPR then
			local C1 = "|cffffffff"
			local C2 = "|cffa6a6ff"
			local C3 = "|cff20ff20"
			local pName = UnitName("player")
			local pLVL = UnitLevel("player")
			local label = ""
			if not (pLVL == 70) then
				local cXP = UnitXP("player")
				local nXP = UnitXPMax("player")
				local rXP = GetXPExhaustion()
				local numbXP = C1..format("[%.f/%.f", cXP, nXP)
				local percXP = C2..format("(%.1f%%)", (cXP / nXP * 100))
				local restXP = ""
				if(rXP ~= nil) then
					restXP = C3.."+"..rXP
				end
				if self.db.profile.showPlayerName then
					if self.db.profile.showPlayerLevel then
						if self.db.profile.showPlayerXPN then
							if self.db.profile.showPlayerXPP then
								if self.db.profile.showPlayerXPR then
									label = pName.." - "..L["HPLEVEL"]..pLVL.." "..numbXP.." "..percXP..C1.."] "..restXP
								else
									label = pName.." - "..L["HPLEVEL"]..pLVL.." "..numbXP.." "..percXP..C1.."]"
								end
							elseif self.db.profile.showPlayerXPR then
								label = pName.." - "..L["HPLEVEL"]..pLVL.." "..numbXP.."] "..restXP
							else
								label = pName.." - "..L["HPLEVEL"]..pLVL.." "..numbXP.."]"
							end
						elseif self.db.profile.showPlayerXPP then
							if self.db.profile.showPlayerXPR then
								label = pName.." - "..L["HPLEVEL"]..pLVL.." "..percXP.." "..restXP
							else
								label = pName.." - "..L["HPLEVEL"]..pLVL.." "..percXP
							end
						elseif self.db.profile.showPlayerXPR then
							label = pName.." - "..L["HPLEVEL"]..pLVL.." "..restXP
						else
							label = pName.." - "..L["HPLEVEL"]..pLVL
						end
					elseif self.db.profile.showPlayerXPN then
						if self.db.profile.showPlayerXPP then
							if self.db.profile.showPlayerXPR then
								label = pName.." "..numbXP.." "..percXP..C1.."] "..restXP
							else
								label = pName.." "..numbXP.." "..percXP..C1.."]"
							end
						elseif self.db.profile.showPlayerXPR then
							label = pName.." "..numbXP.."] "..restXP
						else
							label = pName.." "..numbXP.."]"
						end
					elseif self.db.profile.showPlayerXPP then
						if self.db.profile.showPlayerXPR then
							label = pName.." "..percXP.." "..restXP
						else
							label = pName.." "..percXP
						end
					elseif self.db.profile.showPlayerXPR then
							label = pName.." "..restXP
					else
						label = pName
					end
				elseif self.db.profile.showPlayerLevel then
					if self.db.profile.showPlayerXPN then
						if self.db.profile.showPlayerXPP then
							if self.db.profile.showPlayerXPR then
								label = L["HPLEVEL"]..pLVL.." "..numbXP.." "..percXP..C1.."] "..restXP
							else
								label = L["HPLEVEL"]..pLVL.." "..numbXP.." "..percXP..C1.."]"
							end
						elseif self.db.profile.showPlayerXPR then
							label = L["HPLEVEL"]..pLVL.." "..numbXP.."] "..restXP
						else
							label = L["HPLEVEL"]..pLVL.." "..numbXP.."]"
						end
					elseif self.db.profile.showPlayerXPP then
						if self.db.profile.showPlayerXPR then
							label = L["HPLEVEL"]..pLVL.." "..percXP.." "..restXP
						else
							label = L["HPLEVEL"]..pLVL.." "..percXP
						end
					elseif self.db.profile.showPlayerXPR then
						label = L["HPLEVEL"]..pLVL.." "..restXP
					else
						label = L["HPLEVEL"]..pLVL
					end
				elseif self.db.profile.showPlayerXPN then
					if self.db.profile.showPlayerXPP then
						if self.db.profile.showPlayerXPR then
							label = numbXP.." "..percXP..C1.."] "..restXP
						else
							label = numbXP.." "..percXP..C1.."]"
						end
					elseif self.db.profile.showPlayerXPR then
						label = numbXP.."] "..restXP
					else
						label = numbXP.."]"
					end
				elseif self.db.profile.showPlayerXPP then
					if self.db.profile.showPlayerXPR then
						label = percXP.." "..restXP
					else
						label = percXP
					end
				elseif self.db.profile.showPlayerXPR then
					label = restXP
				end
			elseif self.db.profile.showPlayerName then
				if self.db.profile.showPlayerLevel then
					if self.db.profile.showPlayerXPN or self.db.profile.showPlayerXPP or self.db.profile.showPlayerXPR then
						label = pName.." - "..L["HPLEVEL"]..pLVL
					end
				else
					label = pName
				end
			elseif self.db.profile.showPlayerLevel then
				label = L["HPLEVEL"]..pLVL
			end
			self:SetText(label)
		else
			self:SetText(L["TITLE"])
		end
		self:SetIcon("Interface\\AddOns\\FuBar_PlayerInFu\\icons\\playerfu.tga")
	end
end	



--------------------LEFT CLICKY FUNCTIONS--------------------	
function PlayerInFu:OnClick()
	ToggleCharacter("PaperDollFrame")
end
